// pages/chooseLocation/addLocation/addLocation.js
var app = getApp()
var config = {};
var miucms = require('../../../utils/miucms.js');
Component({
  /**
   * 组件的属性列表
   */
  properties: {

  },

  /**
   * 组件的初始数据
   */
  data: {
    show: false,
    countryList: [],
    countryID: '',
    countryName: '',
    countryAlias: "",
    currencyList: [],
    currencyID: '',
    currencyName: '',
    currencyAlias: "",

    showAlert: false,
    name: '',
    alias: '',
    token: "",
    message:'',
    isSubmit:false
  },

  /**
   * 组件的方法列表
   */
  methods: {
   
    // 隐藏组件
    back() {
      this.setData({
        show: false
      })
    },
    // 父组件触发显示
    showPage() {
      this.setData({
        show: true
      })
      if (this.data.countryList.length == 0 ) {
        this.getList()
      }
    },
    // 获取国家列表
    getList() {
      let url = app.globalData.config.post.regionPlus || 'https://app.gter.net/tenement/post/regionPlus';
      miucms.request(url, {}).then(data => {
        if(data.code!=200){return false}
        data.data.countryList.forEach(item => {
          item['value'] = item.cid
        })
        let currencyList = []
        for (let i in data.data.currencycodes) {
          currencyList.push({
            name: data.data.currencycodes[i],
            value: i,
            alias: i
          })
        }
        currencyList.sort((a, b) => a.value.localeCompare(b.value));
        data.data.countryList.sort((a, b) => a.alias.localeCompare(b.alias));
        this.setData({
          countryList: data.data.countryList,
          currencyList,
          token: data.data.token
        })
      }).then(res => {
        console.log(res)
      })
    },
    // 国家选好了
    submitCountry(e) {
      this.setData({
        countryID: e.detail.value,
        countryName: e.detail.name,
        countryAlias: e.detail.alias
      })
    },
    // 货币选好了
    submitCurrency(e) {
      this.setData({
        currencyID: e.detail.value,
        currencyName: e.detail.name,
        currencyAlias: e.detail.alias
      })
    },

    // 輸入
    input(e) {
      let name = e.currentTarget.dataset.name;
      let value = e.detail.value;
      this.data[name] = value;
      if (name == 'name') {
        this.setData({
          name: value
        })
      } else {
        this.setData({
          alias: value
        })
      }
    },
    // 提交
    submit() {
      if (this.data.isSubmit){return false}
      this.setData({
        isSubmit:true
      })
      let url = app.globalData.config.post.regionPlus || 'https://app.gter.net/tenement/post/regionPlus';
      miucms.request(url, {
        token: this.data.token,
        info: {
          cid: this.data.countryID,
          name: this.data.name,
          alias: this.data.alias,
          currencycode: this.data.currencyAlias,

        }
      }).then(data => {
        this.setData({
          isSubmit:false
        })
        if(data.code==200){
          wx.navigateTo({
            url: `/pages/edit/edit?uniqid=${data.data.uniqid}`,
          })
        }
        if(data.code==201){
          this.setData({
            showAlert:true,
            message:data.message
          })
        }

      }).then(res => {
        this.setData({
          isSubmit: false
        })
      })
    },
    // 隐藏弹窗
    hideAlert(){
      this.setData({
        showAlert:false
      })
    }
  },

})