// pages/report/report.js
var app = getApp()
var miucms = require('../../utils/miucms.js');
var config = {};
Page({

  /**
   * 页面的初始数据
   */
  data: {
    items:[
      { name: '广告、恶意灌水', checked: false, value: "1" },
      { name: '欺诈、色情、违规内容', checked: false, value: "2" },
      
      { name: '信息过时、不实信息、侵权', checked: false, value: "3" },
      { name: '功能异常、产品建议', checked: false, value: "4" },
    ],
    otherSelect:false,
    additional_explanation:'',
    is_submit:false,
    types:'',
    id:''

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      'types':options.types || '',
      id: options.id || '',
      message:[]
    })
  },

 input(e){
   this.setData({
     additional_explanation: e.detail.value
   })
 },
  selectItem(e) {
    let index = e.currentTarget.dataset.index;
    this.data.items[index].checked = !this.data.items[index].checked;
    this.setData({
      items:this.data.items
    })
  },
  selectOthers(e){
    let select = e.currentTarget.dataset.select;
    this.setData({
      otherSelect: select || !this.data.otherSelect
    })
  },
  submit(e){
    if (this.data.is_submit || !app.globalData.config || !app.globalData.config.report){return false}
    var that = this;
   
    let message = [];
    this.data.items.forEach(item=>{
      if(item.checked){
        message.push(item.name)
      }
    })
    if(this.data.otherSelect){
      message.push('其他')
    }
    message.push(this.data.additional_explanation)
    this.setData({
      is_submit: true
    })
    miucms.request(app.globalData.config.report.init, {
      'type':this.data.types,
      id:this.data.id,
      message,
    }).then(data => {
      wx.hideLoading()
      that.setData({
        is_submit: false
      })
      if(data.code==200){
        // 操作成功
        wx.showModal({
          title: '提示',
          content: data.message,
          showCancel:false,
          success() {
            wx.navigateBack({

            })
          }
        })
      }else{
        wx.showModal({
          title: '提示',
          content: data.message,
          showCancel:false,
          
        })
      }
      
    }).catch(res => {
      wx.hideLoading()
      that.setData({
        is_submit: false
      })
      wx.showModal({
        title: '提示',
        content: '抱歉，网络出错。请稍后重试~',
      })
    })

  }
 
})