var initial_url = 'https://app.gter.net/tenement';
var app = null;

function initial(self) {
  app = self;
  getUserInfo(function (code) {
    sendData(code)
    self.globalData.code = code;
  });
  return true;
}

function sendData(code) {
  let Authorization = wx.getStorageSync('Authorization')
  if (!Authorization) {
    Authorization = app.randomString(32)
    wx.setStorageSync('Authorization', Authorization)
    wx.setStorageSync('session', Authorization)
  }
  wx.request({
    url: initial_url,
    data: {
      session: wx.getStorageSync('Authorization') || "",
      Authorization: wx.getStorageSync('Authorization') || "",
      code: code,
      options: app.globalData.options || '',
    },
    method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
    header: {
      'content-type': 'application/json',
      'Accept': 'application/json, text/plain',
      'Cookie': 'miucms_session=' + wx.getStorageSync('Authorization'),
      'Authorization': wx.getStorageSync('Authorization') || ''
    },
    success: function (res) {
      // console.log(res)
      var data = typeof res.data == 'string' ? JSON.parse(res.data) : res.data;
      // 将配置与用户session存于本地
      // if (!data.session) {
      //   // 这里报错.用户授权不成功
      //   return false;
      // }
      // wx.setStorageSync('session', data.user.session)
      app.globalData.session = data.user.session;
      // wx.setStorageSync('Authorization', data.user.session)
      app.globalData.Authorization = data.user.session;
      app.globalData.isUserAuthorization = data.user.session && data.user.session.length > 0 ? 2 : 1;
      app.globalData.expiration_day = data.expiration_day;
      app.globalData.config = data.config;
      app.globalData.notice = data.notice;
      app.globalData.title = data.title;
      app.globalData.user = data.user;
      app.globalData.status = data.status;
      app.globalData.StudentapartmentNew = data.StudentapartmentNew;
      app.globalData.listTab = data.listTab;

      app.globalData.header = {
        'content-type': 'application/json',
        'Accept': 'application/json, text/plain',
        'Cookie': 'miucms_session=' + wx.getStorageSync('Authorization'),
        'Authorization': wx.getStorageSync('Authorization') || ''
      };

      // count()
    },
    fail: function () {
      // fail
    },
    complete: function () {
      // complete
    }
  })
}

// 发送未读消息数请求
function count() {
  return new Promise((resolve, reject) => {
    request(app.globalData.baseURL + "/tenement/message/count").then(res => {
      if (res.code == 200) {
        app.globalData['unreadMessages'] = res.data.count
        app.globalData['unreadMessagesState'] = true
      } else {
        wx.showModal({
          title: '提示',
          content: res.message
        })
      }
      resolve(res)
    }).catch(error => {
      reject(error)
    })
  })
}

// 发送验证码
function verify() {
  // 得到 uniqid 和过期时间
}

// 验证验证码并注册
function register(o) {
  var config = wx.getStorageSync('config')
  // console.log('register',config)
  var self = this;
  wx.request({
    url: config.user.register,
    data: {
      session: wx.getStorageSync('session'),
      data: wx.getStorageSync('rawData'),
      uniqid: null, //上一步获取的ID
      code: null, //接收到的验证码
    },
    method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
    header: {
      'content-type': 'application/json',
      'Accept': 'application/json, text/plain'
    },
    success: function (res) {
      var data = typeof res.data == 'string' ? JSON.parse(res.data) : res.data;
      console.log('登录/注册成功')
      initial(initial_url, app)
    },
    fail: function () {
      // fail
    },
    complete: function () {
      // complete
    }
  })
}


//用户登录
function login() {
  return new Promise((resolve, reject) => wx.login({
    success: resolve,
    fail: reject
  }))
}

//获取用户信息
function getUserInfo(o) {
  // console.log('getUserInfogetUserInfo')
  login().then(res => {
      var code = res.code;
      o(code);
      // wx.getUserInfo({
      //   success: function (res) { 

      //     app.globalData.isUserAuthorization = 2;
      //     console.log('getUserInfosuccess', app.globalData.isUserAuthorization)

      //   },
      //   fail: function (res) { 
      //     app.globalData.isUserAuthorization = 1;
      //     console.log('getUserInfofail', app.globalData.isUserAuthorization)
      //     o(code);
      //   }
      // })
    })
    .catch(res => {
      console.log(res)
    })

}

function share(app, name) {
  if (!app.globalData.config.stat || !app.globalData.config.stat.share) {
    return false
  }
  wx.request({
    url: app.globalData.config.stat.share,
    data: {
      page: name
    },
    method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
    header: app.globalData.header,
    success: function (res) {},
    fail: function (res) {},

  })
}

function html2wxml(str, index, that) {
  var arr = [];
  if (str.indexOf('</a>') != -1) {
    // 有a标签
    that.data.newFunction.text[index].push({
      text: str.substring(0, str.indexOf('<a')),
      node: 'text'
    })
    var rest = str.substring(str.indexOf('<a'));
    // a标签后面剩下的字符串
    // 第一个出现href的位置
    var href1 = rest.indexOf('href="') + 6;
    // 第二个“出现的位置
    var href2 = (rest.substring(href1)).indexOf('"')
    // 链接地址
    var href = rest.substring(href1, href1 + href2)
    rest = rest.substring(rest.indexOf('>'));
    // console.log('rest', rest)
    var text1 = rest.substring(1, rest.indexOf('</a>'))
    that.data.newFunction.text[index].push({
      text: text1,
      node: 'a',
      href: href
    })
    rest = rest.substring(rest.indexOf('</a>') + 4)
    if (rest.length > 0) {
      // a标签后还有字符串
      if (rest.indexOf('</a>') != -1) {
        // 还有A标签存在，再一次调用
        that.html2wxml(rest, index)
      } else {
        that.data.newFunction.text[index].push({
          text: rest,
          node: 'text',
        })
      }
    }
  } else {
    that.data.newFunction.text[index] = [{
      text: str,
      node: 'text',
    }]
  }
}

function change_data(that, newFunction) {
  var arr = newFunction.split('\n');
  var arr2 = [];
  for (var i = 0; i < arr.length; i++) {
    var str = arr[i];
    that.data.newFunction.text[i] = [];
    that.html2wxml(str, i)
  }
  that.setData({
    newFunction: that.data.newFunction
  })
}

function copy(content, hintText) {
  return new Promise((resolve, reject) => {
    wx.setClipboardData({
      data: content,
      success: function (res) {
        wx.getClipboardData({
          success: function (res) {
            wx.showToast({
              title: hintText || '复制成功！',
            })
            resolve()
          }
        })
      },
      fail(err) {
        reject(err)
      }
    })
  })

}

//封装Request请求方法
function request(url, data = {}, needGet = false) {
  return new Promise((resolve, reject) => {
    // if (!app.globalData.config || !app.globalData.config.list) {
    //   reject()
    //   return false
    // }
    let sendData = Object.assign({
      session: wx.getStorageSync('session'),
    }, app.globalData.options, data)
    wx.request({
      url: url,
      data: sendData,
      header: {
        'content-type': 'application/json',
        'Accept': 'application/json, text/plain',
        'Cookie': 'miucms_session=' + wx.getStorageSync('Authorization'),
        'Authorization': wx.getStorageSync('Authorization') || ''
      },
      method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
      success: function (res) {
        var json = res.data;
        if (typeof json != 'object') {
          if (json != null) {
            json = json.replace("\ufeff", "");
            try {
              var jj = JSON.parse(json);
              res.data = jj;
            } catch (error) {
              wx.showModal({
                title: '提示',
                content: '请求失败'
              })
            }

          }
        }
        var data = res.data;
        resolve(data)

      },
      fail: function (msg) {
        wx.hideLoading();
        console.log('errmsg', msg)
        wx.showToast({
          title: msg,
          icon: 'none',
          duration: 2000,
          mask: true
        })
        reject('fail')
      }
    })
  })
}

const wxget = function (url, data = {}) {
  return new Promise((resolve, reject) => {
    var authorization = wx.getStorageSync('Authorization');
    wx.request({
      url: url,
      data: data,
      header: {
        'Cookie': 'miucms_session=' + authorization,
        Authorization: authorization
      },
      method: 'GET',
      success: (res) => {
        if (res.data.code == 200) {
          resolve(res.data)
        } else if (res.data.code == 401) {
          // 需要授权
          // console.log(app)
          app.globalData.user.uid = 0;
          wx.showToast({
            icon: 'none',
            title: res.data.message
          })
          reject(res)
        } else {
          wx.hideLoading()
          wx.showModal({
            title: '提示',
            content: res.data.message,
          })
          reject(res.data)
        }

      },
      fail(res) {
        wx.showModal({
          title: '提示',
          content: res,
        })
        reject(res)
      }
    });
  })

}

function closeAD(id) {
  // console.log(id)
  if (!app.globalData.config || !app.globalData.config.adv) {
    return false
  }
  request(app.globalData.config.adv.close, {
    advid: id
  }).then(res => {})
}

function clickAD(id) {
  if (!app.globalData.config || !app.globalData.config.adv) {
    return false
  }
  request(app.globalData.config.adv.click, {
    advid: id
  }).then(res => {})
}

module.exports = {
  initial: initial,
  share: share,
  change_data: change_data,
  html2wxml: html2wxml,
  copy,
  sendData,
  request,
  wxget,
  closeAD,
  clickAD,
  count,
  https: function (url, data, success, fail) {
    wx.request({
      url: url,
      data: data,
      method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
      header: {
        'content-type': 'application/json',
        'Accept': 'application/json, text/plain',
        'Cookie': 'miucms_session=' + wx.getStorageSync('Authorization'),
        'Authorization': wx.getStorageSync('Authorization') || ''
      },
      success: function (res) {
        typeof success == 'function' && success(res);
      },
      fail: function () {
        typeof fail == 'function' && fail(res);
      },
      complete: function () {
        typeof fail == 'function' && fail(res);
      }
    })
  },
}